
/*  A Bison parser, made from scheme.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	LPAREN	257
#define	LVECTPAREN	258
#define	RPAREN	259
#define	DEFINE	260
#define	SET	261
#define	LAMBDA	262
#define	BEGINTOK	263
#define	AND	264
#define	OR	265
#define	CASE	266
#define	COND	267
#define	ELSE	268
#define	ARROW	269
#define	CALLCC	270
#define	APPLY	271
#define	IF	272
#define	LET	273
#define	LETSTAR	274
#define	LETREC	275
#define	DOT	276
#define	INTEGER	277
#define	CHAR	278
#define	BOOLEAN	279
#define	DOUBLE	280
#define	SYMBOL	281
#define	STRING	282
#define	QUOTECHAR	283
#define	QUOTE	284

#line 1 "scheme.y"

#import "SchemeTypes.h"

#define YYSTYPE id

YYSTYPE yyresult;
int yyinputitem;
id yyresultform;

extern int yysofar;
extern NSMutableArray *positionStack;
#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		206
#define	YYFLAG		-32768
#define	YYNTBASE	31

#define YYTRANSLATE(x) ((unsigned)(x) <= 284 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,    10,    16,    18,    20,    23,    25,    28,
    30,    32,    34,    36,    38,    40,    42,    44,    47,    49,
    51,    53,    55,    57,    59,    61,    63,    65,    67,    69,
    71,    73,    75,    77,    79,    81,    83,    85,    87,    89,
    91,    93,    95,    97,    99,   101,   103,   105,   107,   109,
   111,   113,   115,   117,   119,   121,   123,   125,   130,   137,
   141,   146,   152,   157,   159,   162,   164,   167,   173,   180,
   185,   191,   196,   200,   205,   209,   214,   220,   226,   232,
   239,   245,   251,   254,   259,   264,   266,   269,   277,   285,
   293,   296,   298,   302,   305,   307,   311,   314,   316,   319,
   321,   324,   328,   332,   334,   336,   338,   340,   344,   347,
   351,   354,   356,   360,   363,   367,   369
};

static const short yyrhs[] = {    -1,
    32,    31,     0,     3,     6,    27,    36,     5,     0,     3,
     6,    70,    33,     5,     0,    36,     0,    36,     0,    36,
    33,     0,    36,     0,    34,    36,     0,    23,     0,    24,
     0,    25,     0,    26,     0,    27,     0,    28,     0,    66,
     0,    68,     0,    29,    35,     0,    15,     0,    30,     0,
    16,     0,    17,     0,     6,     0,     7,     0,     8,     0,
    18,     0,     9,     0,    10,     0,    11,     0,    12,     0,
    13,     0,    14,     0,    19,     0,    20,     0,    21,     0,
    23,     0,    24,     0,    25,     0,    26,     0,    27,     0,
    28,     0,    65,     0,    67,     0,    51,     0,    50,     0,
    55,     0,    56,     0,    57,     0,    52,     0,    49,     0,
    48,     0,    47,     0,    45,     0,    46,     0,    43,     0,
    44,     0,    37,     0,     3,    16,    36,     5,     0,     3,
     3,    33,     5,    33,     5,     0,     3,    36,     5,     0,
     3,    36,    33,     5,     0,     3,    36,    15,    36,     5,
     0,     3,    14,    33,     5,     0,    38,     0,    41,    38,
     0,    39,     0,    42,    39,     0,     3,    12,    36,    41,
     5,     0,     3,    12,    36,    41,    40,     5,     0,     3,
    13,    42,     5,     0,     3,    13,    42,    40,     5,     0,
     3,    10,    34,     5,     0,     3,    10,     5,     0,     3,
    11,    34,     5,     0,     3,    11,     5,     0,     3,     9,
    33,     5,     0,     3,     7,    27,    36,     5,     0,     3,
    17,    36,    36,     5,     0,     3,    18,    36,    36,     5,
     0,     3,    18,    36,    36,    36,     5,     0,     3,     8,
    27,    33,     5,     0,     3,     8,    71,    33,     5,     0,
    29,    35,     0,     3,    30,    35,     5,     0,     3,    27,
    36,     5,     0,    53,     0,    53,    54,     0,     3,    19,
     3,    54,     5,    33,     5,     0,     3,    20,     3,    54,
     5,    33,     5,     0,     3,    21,     3,    54,     5,    33,
     5,     0,     3,     5,     0,    36,     0,    36,    22,    36,
     0,    36,    59,     0,    35,     0,    35,    22,    35,     0,
    35,    60,     0,    36,     0,    36,    61,     0,    35,     0,
    35,    62,     0,     3,    59,     5,     0,     3,    60,     5,
     0,    63,     0,    58,     0,    64,     0,    58,     0,     4,
    61,     5,     0,     4,     5,     0,     4,    62,     5,     0,
     4,     5,     0,    27,     0,    27,    22,    27,     0,    27,
    69,     0,     3,    69,     5,     0,    70,     0,    58,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    56,    60,    68,    76,    84,    94,    97,   102,   105,   110,
   113,   116,   119,   122,   125,   128,   131,   134,   138,   141,
   144,   147,   150,   153,   156,   159,   162,   165,   168,   171,
   174,   177,   180,   183,   186,   191,   194,   197,   200,   203,
   206,   209,   212,   215,   218,   221,   224,   227,   230,   233,
   236,   239,   242,   245,   248,   251,   254,   259,   264,   269,
   272,   275,   280,   285,   288,   293,   296,   301,   304,   310,
   313,   318,   321,   326,   329,   334,   339,   344,   349,   352,
   357,   360,   365,   368,   373,   378,   381,   386,   391,   396,
   401,   406,   409,   412,   417,   420,   423,   428,   431,   436,
   439,   444,   449,   454,   457,   462,   465,   470,   473,   478,
   481,   486,   489,   492,   497,   502,   505
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","LPAREN",
"LVECTPAREN","RPAREN","DEFINE","SET","LAMBDA","BEGINTOK","AND","OR","CASE","COND",
"ELSE","ARROW","CALLCC","APPLY","IF","LET","LETSTAR","LETREC","DOT","INTEGER",
"CHAR","BOOLEAN","DOUBLE","SYMBOL","STRING","QUOTECHAR","QUOTE","top","topitem",
"sequence","revsequence","qform","form","callcc","singlecase","singlecond","elsecasecond",
"cases","conditions","case","cond","and","or","begin","set","apply","if","lambda",
"quote","singlebinding","listofbindings","let","letstar","letrec","emptylist",
"nonemptylistdata","qnonemptylistdata","nonemptyvectdata","qnonemptyvectdata",
"nonemptylist","qnonemptylist","list","qlist","vector","qvector","nonemptysymlistdata",
"nonemptysymlist","symlist", NULL
};
#endif

static const short yyr1[] = {     0,
    31,    31,    32,    32,    32,    33,    33,    34,    34,    35,
    35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
    35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
    35,    35,    35,    35,    35,    36,    36,    36,    36,    36,
    36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
    36,    36,    36,    36,    36,    36,    36,    37,    38,    39,
    39,    39,    40,    41,    41,    42,    42,    43,    43,    44,
    44,    45,    45,    46,    46,    47,    48,    49,    50,    50,
    51,    51,    52,    52,    53,    54,    54,    55,    56,    57,
    58,    59,    59,    59,    60,    60,    60,    61,    61,    62,
    62,    63,    64,    65,    65,    66,    66,    67,    67,    68,
    68,    69,    69,    69,    70,    71,    71
};

static const short yyr2[] = {     0,
     0,     2,     5,     5,     1,     1,     2,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     4,     6,     3,
     4,     5,     4,     1,     2,     1,     2,     5,     6,     4,
     5,     4,     3,     4,     3,     4,     5,     5,     5,     6,
     5,     5,     2,     4,     4,     1,     2,     7,     7,     7,
     2,     1,     3,     2,     1,     3,     2,     1,     2,     1,
     2,     3,     3,     1,     1,     1,     1,     3,     2,     3,
     2,     1,     3,     2,     3,     1,     1
};

static const short yydefact[] = {     1,
     0,     0,    36,    37,    38,    39,    40,    41,     0,     1,
     5,    57,    55,    56,    53,    54,    52,    51,    50,    45,
    44,    49,    46,    47,    48,   105,   104,    42,    43,     0,
    91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    92,     0,   109,    98,
     0,     0,     0,    23,    24,    25,    27,    28,    29,    30,
    31,    32,    19,    21,    22,    26,    33,    34,    35,    10,
    11,    12,    13,    14,    15,     0,    20,    83,   107,   106,
    16,    17,     2,     0,     0,     0,     0,     0,     0,   117,
   116,     0,     0,     6,    73,     0,     8,    75,     0,     0,
     0,    66,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    94,   102,    99,   108,    95,     0,   111,   100,     0,
    18,   112,     0,     0,     0,     0,     0,     0,    76,     7,
    72,     9,    74,     0,    64,     0,     0,     0,    70,    67,
     0,    58,     0,     0,     0,    86,     0,     0,     0,    84,
    93,     0,    97,   103,   101,   110,     0,   114,   115,     3,
     4,    77,    81,    82,     0,     0,    68,    65,     0,    60,
     0,     0,     0,    71,    78,    79,     0,     0,    87,     0,
     0,     0,    96,   113,     0,    69,     0,    61,     0,    80,
     0,     0,     0,     0,     0,    62,    63,    85,    88,    89,
    90,     0,    59,     0,     0,     0
};

static const short yydefgoto[] = {    83,
    10,    93,    96,   116,    94,    12,   135,   102,   141,   136,
   103,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,   146,   147,    23,    24,    25,    26,    48,   117,    51,
   120,    27,    80,    28,    81,    29,    82,   123,    86,    92
};

static const short yypact[] = {   139,
   288,   344,-32768,-32768,-32768,-32768,-32768,-32768,   260,   139,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   316,
-32768,     1,   -13,     4,   433,   351,   358,   433,    12,   433,
   433,   433,    15,    20,    23,   260,   385,    27,-32768,   433,
    29,   176,   204,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   260,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,     8,   433,   433,   433,    -2,   433,-32768,
-32768,   433,    34,   433,-32768,   392,-32768,-32768,   399,    41,
   433,-32768,    19,    44,   433,   433,    43,    43,    43,    48,
   433,-32768,-32768,-32768,-32768,   232,    49,-32768,   260,    51,
-32768,   -10,    52,    53,    54,    55,    56,    57,-32768,-32768,
-32768,-32768,-32768,    60,-32768,    24,   132,   100,-32768,-32768,
    61,-32768,    62,   426,    38,    43,    63,    64,    65,-32768,
-32768,   260,-32768,-32768,-32768,-32768,    45,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   433,     6,-32768,-32768,    66,-32768,
   433,    68,   433,-32768,-32768,-32768,    69,   433,-32768,   433,
   433,   433,-32768,-32768,    71,-32768,    72,-32768,    74,-32768,
    75,    76,    77,    78,   433,-32768,-32768,-32768,-32768,-32768,
-32768,    79,-32768,    86,    88,-32768
};

static const short yypgoto[] = {    89,
-32768,   -73,    58,     2,     0,-32768,   -46,   -12,   -43,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  -103,-32768,-32768,-32768,    -1,    47,   -19,    67,
   -21,-32768,-32768,-32768,-32768,-32768,-32768,   -20,    82,-32768
};


#define	YYLAST		462


static const short yytable[] = {    11,
    47,    50,    31,    84,   148,   149,    88,    79,   165,    11,
    78,   157,   125,    87,   101,   127,   122,   107,   128,   173,
   130,   138,   108,   139,   122,   109,   166,    85,   167,    47,
    89,   113,    90,   115,   122,    97,    97,   100,   129,   104,
   105,   106,   179,   134,    79,   145,    47,   110,   142,    50,
    79,    79,   150,   154,   119,   156,   159,   160,   161,   162,
   163,   164,   165,   172,   178,   174,   175,   180,   181,   182,
   186,   184,   188,   190,    79,   195,   196,   121,   197,   198,
   199,   200,   201,   203,   124,   205,   126,   206,   204,   168,
   140,   185,   169,   112,    99,   132,   153,   155,   132,   189,
   137,   158,    30,     2,   143,   144,   192,   193,   194,     0,
   151,     0,     0,   173,    79,    91,   114,    79,     0,     0,
   119,   202,     3,     4,     5,     6,     7,     8,     9,     0,
     0,     0,     0,     0,    30,     2,   170,   137,     0,     0,
     0,     1,     2,   177,     0,     0,   171,     0,     0,     0,
    79,     0,     0,   183,     3,     4,     5,     6,     7,     8,
     9,     3,     4,     5,     6,     7,     8,     9,     0,     0,
   187,     0,     0,     0,     0,     0,     0,   191,    52,    53,
    31,    54,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,     0,    70,    71,
    72,    73,    74,    75,    76,    77,    52,    53,   118,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,     0,    70,    71,    72,    73,
    74,    75,    76,    77,    52,    53,     0,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,   152,    70,    71,    72,    73,    74,    75,
    76,    77,    52,    53,     0,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,     0,    70,    71,    72,    73,    74,    75,    76,    77,
    30,     2,    31,    32,    33,    34,    35,    36,    37,    38,
    39,     0,     0,    40,    41,    42,    43,    44,    45,     0,
     3,     4,     5,     6,     7,     8,     9,    46,    30,     2,
    31,     0,    33,    34,    35,    36,    37,    38,    39,     0,
     0,    40,    41,    42,    43,    44,    45,     0,     3,     4,
     5,     6,     7,     8,     9,    46,    30,     2,    49,     0,
     0,     0,     0,    30,     2,    95,     0,     0,     0,     0,
    30,     2,    98,     0,     0,     0,     3,     4,     5,     6,
     7,     8,     9,     3,     4,     5,     6,     7,     8,     9,
     3,     4,     5,     6,     7,     8,     9,    30,     2,     0,
     0,     0,     0,     0,    30,     2,   131,     0,     0,     0,
     0,    30,     2,   133,     0,     0,   111,     3,     4,     5,
     6,     7,     8,     9,     3,     4,     5,     6,     7,     8,
     9,     3,     4,     5,     6,     7,     8,     9,    30,     2,
   176,     0,     0,     0,     0,    30,     2,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     3,     4,
     5,     6,     7,     8,     9,     3,     4,     5,     6,     7,
     8,     9
};

static const short yycheck[] = {     0,
     1,     2,     5,     3,   108,   109,     3,     9,     3,    10,
     9,    22,    86,    27,     3,    89,    27,     3,    92,    14,
    94,     3,     3,     5,    27,     3,     3,    27,     5,    30,
    27,     5,    34,     5,    27,    36,    37,    38,     5,    40,
    41,    42,   146,     3,    46,     3,    47,    46,     5,    50,
    52,    53,     5,     5,    53,     5,     5,     5,     5,     5,
     5,     5,     3,   137,    27,     5,     5,     5,     5,     5,
     5,    27,     5,     5,    76,     5,     5,    76,     5,     5,
     5,     5,     5,     5,    85,     0,    87,     0,     0,   136,
   103,   165,   136,    47,    37,    96,   116,   119,    99,   173,
   101,   122,     3,     4,   105,   106,   180,   181,   182,    -1,
   111,    -1,    -1,    14,   116,    34,    50,   119,    -1,    -1,
   119,   195,    23,    24,    25,    26,    27,    28,    29,    -1,
    -1,    -1,    -1,    -1,     3,     4,     5,   138,    -1,    -1,
    -1,     3,     4,   144,    -1,    -1,    15,    -1,    -1,    -1,
   152,    -1,    -1,   152,    23,    24,    25,    26,    27,    28,
    29,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
   171,    -1,    -1,    -1,    -1,    -1,    -1,   178,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
    25,    26,    27,    28,    29,    30,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
    27,    28,    29,    30,     3,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,     3,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    -1,    -1,    16,    17,    18,    19,    20,    21,    -1,
    23,    24,    25,    26,    27,    28,    29,    30,     3,     4,
     5,    -1,     7,     8,     9,    10,    11,    12,    13,    -1,
    -1,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
    25,    26,    27,    28,    29,    30,     3,     4,     5,    -1,
    -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,    -1,
     3,     4,     5,    -1,    -1,    -1,    23,    24,    25,    26,
    27,    28,    29,    23,    24,    25,    26,    27,    28,    29,
    23,    24,    25,    26,    27,    28,    29,     3,     4,    -1,
    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,
    -1,     3,     4,     5,    -1,    -1,    22,    23,    24,    25,
    26,    27,    28,    29,    23,    24,    25,    26,    27,    28,
    29,    23,    24,    25,    26,    27,    28,    29,     3,     4,
     5,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
    25,    26,    27,    28,    29,    23,    24,    25,    26,    27,
    28,    29
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif


#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 222 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
YYPARSE_RETURN_TYPE
yyparse (void *);
#else
YYPARSE_RETURN_TYPE
yyparse (void);
#endif
#endif

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
#ifndef YYSTACK_USE_ALLOCA
  int yyfree_stacks = 0;
#endif

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
#ifndef YYSTACK_USE_ALLOCA
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
#endif	    
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 56 "scheme.y"
{
    yyval = [NSNull null];
    yyresultform = yyval;
;
    break;}
case 2:
#line 60 "scheme.y"
{
    yyval = [Triple newTag:FORM_TOP Arg1:yyvsp[-1] Arg2:yyvsp[0]];
    yyresultform = yyval;
    
    yyinputitem++;
;
    break;}
case 3:
#line 68 "scheme.y"
{
    NSValue *entry = 
        [NSValue valueWithRange:NSMakeRange(yysofar, 0)];

    yyval = [Triple newTag:FORM_DEFINE1 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];

    [[positionStack lastObject] addObject:entry];
;
    break;}
case 4:
#line 76 "scheme.y"
{ 
    NSValue *entry = 
        [NSValue valueWithRange:NSMakeRange(yysofar, 0)];

    yyval = [Triple newTag:FORM_DEFINE2 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];

    [[positionStack lastObject] addObject:entry];
;
    break;}
case 5:
#line 84 "scheme.y"
{
    NSValue *entry = 
        [NSValue valueWithRange:NSMakeRange(yysofar, 0)];

    yyval = yyvsp[0];

    [[positionStack lastObject] addObject:entry];
;
    break;}
case 6:
#line 94 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 7:
#line 97 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 8:
#line 102 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 9:
#line 105 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:yyvsp[-1]];
;
    break;}
case 10:
#line 110 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 11:
#line 113 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 12:
#line 116 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 13:
#line 119 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 14:
#line 122 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 15:
#line 125 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 16:
#line 128 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 17:
#line 131 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 18:
#line 134 "scheme.y"
{
    yyval = [Pair newCar:[[Symbol alloc] initSCMSymbol:"quote"]
	       Cdr:[Pair newCar:yyvsp[0] Cdr:[NSNull null]]];
;
    break;}
case 19:
#line 138 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"=>"];
;
    break;}
case 20:
#line 141 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"quote"];
;
    break;}
case 21:
#line 144 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"call-with-current-continuation"];
;
    break;}
case 22:
#line 147 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"apply"];
;
    break;}
case 23:
#line 150 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"define"];
;
    break;}
case 24:
#line 153 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"set!"];
;
    break;}
case 25:
#line 156 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"lambda"];
;
    break;}
case 26:
#line 159 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"if"];
;
    break;}
case 27:
#line 162 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"begin"];
;
    break;}
case 28:
#line 165 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"and"];
;
    break;}
case 29:
#line 168 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"or"];
;
    break;}
case 30:
#line 171 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"case"];
;
    break;}
case 31:
#line 174 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"cond"];
;
    break;}
case 32:
#line 177 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"else"];
;
    break;}
case 33:
#line 180 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"let"];
;
    break;}
case 34:
#line 183 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"let*"];
;
    break;}
case 35:
#line 186 "scheme.y"
{
    yyval = [[Symbol alloc] initSCMSymbol:"letrec"];
;
    break;}
case 36:
#line 191 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 37:
#line 194 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 38:
#line 197 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 39:
#line 200 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 40:
#line 203 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 41:
#line 206 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 42:
#line 209 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 43:
#line 212 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 44:
#line 215 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 45:
#line 218 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 46:
#line 221 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 47:
#line 224 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 48:
#line 227 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 49:
#line 230 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 50:
#line 233 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 51:
#line 236 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 52:
#line 239 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 53:
#line 242 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 54:
#line 245 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 55:
#line 248 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 56:
#line 251 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 57:
#line 254 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 58:
#line 259 "scheme.y"
{
    yyval = [Triple newTag:FORM_CALLCC Arg1:yyvsp[-1]];
;
    break;}
case 59:
#line 264 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-3] Cdr:yyvsp[-1]];
;
    break;}
case 60:
#line 269 "scheme.y"
{
    yyval = [Triple newTag:FORM_SCOND1 Arg1:yyvsp[-1]];
;
    break;}
case 61:
#line 272 "scheme.y"
{
    yyval = [Triple newTag:FORM_SCOND2 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 62:
#line 275 "scheme.y"
{
    yyval = [Triple newTag:FORM_SCOND3 Arg1:yyvsp[-3] Arg2:yyvsp[-1]];
;
    break;}
case 63:
#line 280 "scheme.y"
{
    yyval = [Pair newCar:[NSNull null] Cdr:yyvsp[-1]];
;
    break;}
case 64:
#line 285 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 65:
#line 288 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:yyvsp[-1]];
;
    break;}
case 66:
#line 293 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 67:
#line 296 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:yyvsp[-1]];
;
    break;}
case 68:
#line 301 "scheme.y"
{
    yyval = [Triple newTag:FORM_CASE Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 69:
#line 304 "scheme.y"
{
    yyval = [Triple newTag:FORM_CASE Arg1:yyvsp[-3] 
                 Arg2:[Pair newCar:yyvsp[-1] Cdr:yyvsp[-2]]];
;
    break;}
case 70:
#line 310 "scheme.y"
{
    yyval = [Triple newTag:FORM_COND Arg1:yyvsp[-1]];
;
    break;}
case 71:
#line 313 "scheme.y"
{
    yyval = [Triple newTag:FORM_COND Arg1:[Pair newCar:yyvsp[-1] Cdr:yyvsp[-2]]];
;
    break;}
case 72:
#line 318 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_AND Arg1:yyvsp[-1]];
;
    break;}
case 73:
#line 321 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_AND Arg1:[NSNull null]];
;
    break;}
case 74:
#line 326 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_OR Arg1:yyvsp[-1]];
;
    break;}
case 75:
#line 329 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_OR Arg1:[NSNull null]];
;
    break;}
case 76:
#line 334 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_BEGIN Arg1:yyvsp[-1]];
;
    break;}
case 77:
#line 339 "scheme.y"
{ 
    yyval = [Triple newTag:FORM_SET Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 78:
#line 344 "scheme.y"
{
    yyval = [Triple newTag:FORM_APPLY Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 79:
#line 349 "scheme.y"
{
    yyval = [Triple newTag:FORM_IF1 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 80:
#line 352 "scheme.y"
{
    yyval = [Triple newTag:FORM_IF2 Arg1:yyvsp[-3] Arg2:yyvsp[-2] Arg3:yyvsp[-1]];
;
    break;}
case 81:
#line 357 "scheme.y"
{
    yyval = [Triple newTag:FORM_LAMBDA1 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 82:
#line 360 "scheme.y"
{
    yyval = [Triple newTag:FORM_LAMBDA2 Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 83:
#line 365 "scheme.y"
{
    yyval = [Triple newTag:FORM_QUOTE Arg1:yyvsp[0]];
;
    break;}
case 84:
#line 368 "scheme.y"
{
    yyval = [Triple newTag:FORM_QUOTE Arg1:yyvsp[-1]];
;
    break;}
case 85:
#line 373 "scheme.y"
{
    yyval = [Triple newTag:FORM_BINDING Arg1:yyvsp[-2] Arg2:yyvsp[-1]];
;
    break;}
case 86:
#line 378 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 87:
#line 381 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 88:
#line 386 "scheme.y"
{
    yyval = [Triple newTag:FORM_LET Arg1:yyvsp[-3] Arg2:yyvsp[-1]];
;
    break;}
case 89:
#line 391 "scheme.y"
{
    yyval = [Triple newTag:FORM_LETSTAR Arg1:yyvsp[-3] Arg2:yyvsp[-1]];
;
    break;}
case 90:
#line 396 "scheme.y"
{
    yyval = [Triple newTag:FORM_LETREC Arg1:yyvsp[-3] Arg2:yyvsp[-1]];
;
    break;}
case 91:
#line 401 "scheme.y"
{ 
    yyval = [NSNull null];
;
    break;}
case 92:
#line 406 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 93:
#line 409 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-2] Cdr:yyvsp[0]];
;
    break;}
case 94:
#line 412 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 95:
#line 417 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 96:
#line 420 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-2] Cdr:yyvsp[0]];
;
    break;}
case 97:
#line 423 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 98:
#line 428 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 99:
#line 431 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 100:
#line 436 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 101:
#line 439 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 102:
#line 444 "scheme.y"
{
    yyval = yyvsp[-1];
;
    break;}
case 103:
#line 449 "scheme.y"
{
    yyval = yyvsp[-1];
;
    break;}
case 104:
#line 454 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 105:
#line 457 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 106:
#line 462 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 107:
#line 465 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 108:
#line 470 "scheme.y"
{
    yyval = [Vector newFromList:yyvsp[-1]];
;
    break;}
case 109:
#line 473 "scheme.y"
{
    yyval = [Vector newFromList:(Pair *)[NSNull null]];
;
    break;}
case 110:
#line 478 "scheme.y"
{
    yyval = [Vector newFromList:yyvsp[-1]];
;
    break;}
case 111:
#line 481 "scheme.y"
{
    yyval = [Vector newFromList:(Pair *)[NSNull null]];
;
    break;}
case 112:
#line 486 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[0] Cdr:[NSNull null]];
;
    break;}
case 113:
#line 489 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-2] Cdr:yyvsp[0]];
;
    break;}
case 114:
#line 492 "scheme.y"
{
    yyval = [Pair newCar:yyvsp[-1] Cdr:yyvsp[0]];
;
    break;}
case 115:
#line 497 "scheme.y"
{
    yyval = yyvsp[-1];
;
    break;}
case 116:
#line 502 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
case 117:
#line 505 "scheme.y"
{
    yyval = yyvsp[0];
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 554 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif    
  return 1;
}
#line 510 "scheme.y"


